/*
 * BetweenSupport.java
 * Created on Apr 7, 2003
 */
package org.apache.ojb.taglib.broker.support;

import javax.servlet.jsp.JspException;

/**
 * Description
 * 
 * @author <a href="mailto:jacob.hookom@mckesson.com">Jacob Hookom</a>
 * @version ##build.version## - Created: Apr 7, 2003 12:47:22 AM
 */
public abstract class BetweenSupport extends ConditionalSupport
{
	//	***********************************************************
	// Internal State

	protected String property; // property the condition is on
	protected Object start; // the start value
	protected Object end; // the end value

	// ***********************************************************
	// Construction and Initialization

	/**
	 * Creates and initializes the tag.  Because of the nature of
	 * tags, we cannot expect any other constructor to be called
	 * other than the default constructor.
	 */
	public BetweenSupport()
	{
		super();
		this.init();
	}

	/**
	 * Resets the tag's state
	 */
	private void init()
	{
		this.property = null;
		this.start = null;
		this.end = null;
	}

	/**
	 * Re-initializes the tag for pooling support by the web container
	 * @see javax.servlet.jsp.tagext.Tag#release()
	 */
	public void release()
	{
		super.release();
		this.init();
	}

	// ***********************************************************
	// Tag Methods

	/**
	 * Evaluates value if need be and calls the process
	 * @see javax.servlet.jsp.tagext.Tag#doStartTag()
	 */
	public int doStartTag() throws JspException
	{
		this.doProcess();
		return SKIP_BODY;
	}
}
