/*
 * ConditionalSupport.java
 * Created on Apr 7, 2003
 */
package org.apache.ojb.taglib.broker.support;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.BodyTagSupport;

import org.apache.ojb.broker.query.Criteria;
import org.apache.ojb.broker.query.QueryByCriteria;
import org.apache.ojb.taglib.resources.TagResources;
import org.apache.ojb.taglib.broker.tags.AbstractQueryTag;

/**
 * Description
 * 
 * @author <a href="mailto:jacob.hookom@mckesson.com">Jacob Hookom</a>
 * @version ##build.version## - Created: Apr 7, 2003 12:54:29 AM
 */
public abstract class ConditionalSupport extends BodyTagSupport
{
	public final Criteria getCriteria() throws JspException
	{
		System.out.println("GETTING CRITERIA");
		Criteria criteria = null;

		CriteriaSupport ct =
			(CriteriaSupport) findAncestorWithClass(this, CriteriaSupport.class);

		if (ct != null)
		{
			criteria = ct.getCriteria();
		}

		if (criteria == null)
		{
			System.out.println("THROWING EXCEPTION");

			String message = null;
			try
			{
				message =
					TagResources.getMessage(
						"CONDITIONAL_OUTSIDE_PARENT",
						this.getClass().getName());
			}
			catch (Exception e)
			{
				System.out.println(e);
			}
			throw new JspException(message);
		}

		return criteria;
	}

	public final QueryByCriteria getQuery() throws JspException
	{
		QueryByCriteria query = null;

		AbstractQueryTag qt = (AbstractQueryTag) findAncestorWithClass(this, AbstractQueryTag.class);

		if (qt != null)
			query = qt.getQuery();

		if (query == null)
		{
			throw new JspException(
				TagResources.getMessage(
					"CONDITIONAL_OUTSIDE_PARENT",
					this.getClass().getName()));
		}

		return query;
	}

	// ***********************************************************
	// Supporting Methods

	/**
	 * Grabs the parent tag in search of the Criteria it has and
	 * calls doInternalProcess
	 * @throws JspException
	 */
	protected abstract void doProcess() throws JspException;
}
