/*
 * CriteriaSupport.java
 * Created on Apr 7, 2003
 */
package org.apache.ojb.taglib.broker.support;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.PageContext;
import javax.servlet.jsp.tagext.BodyTagSupport;

import org.apache.ojb.broker.query.Criteria;

/**
 * Description
 * 
 * @author <a href="mailto:jacob.hookom@mckesson.com">Jacob Hookom</a>
 * @version ##build.version## - Created: Apr 7, 2003 1:43:24 AM
 */
public abstract class CriteriaSupport extends BodyTagSupport
{
	// ***********************************************************
	// Internal State

	protected String var; 	// property the condition is on
	protected int scope; 	// the value to check against
	protected Criteria criteria; // the criteria object

	// ***********************************************************
	// Construction and Initialization

	/**
	 * Creates and initializes the tag.  Because of the nature of
	 * tags, we cannot expect any other constructor to be called
	 * other than the default constructor.
	 */
	public CriteriaSupport()
	{
		super();
		this.init();
	}

	/**
	 * Resets the tag's state
	 */
	private void init()
	{
		this.var = null;
		this.scope = PageContext.PAGE_SCOPE;
		this.criteria = null;
	}

	/**
	 * Re-initializes the tag for pooling support by the web container
	 * @see javax.servlet.jsp.tagext.Tag#release()
	 */
	public void release()
	{
		super.release();
		this.init();
	}
	
	// ***********************************************************
	// Accessor Methods
	
	public Criteria getCriteria()
	{
		return this.criteria;
	}

	// ***********************************************************
	// Tag Methods

	/**
	 * Evaluates value if need be and calls the process
	 * @see javax.servlet.jsp.tagext.Tag#doStartTag()
	 */
	public int doStartTag() throws JspException
	{
		this.criteria = new Criteria();
		return EVAL_BODY_BUFFERED;
	}

	/**
	 * If the body needed to be read in, call the process now
	 * @see javax.servlet.jsp.tagext.Tag#doEndTag()
	 */
	public int doEndTag() throws JspException
	{
		if (this.var != null)
		{
			this.pageContext.setAttribute(this.var, this.criteria, this.scope);
		}
		return EVAL_PAGE;
	}
}
