/*
 * Created on Jul 13, 2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package org.apache.ojb.taglib.broker.tags;

import javax.servlet.jsp.JspException;

import org.apache.ojb.taglib.broker.support.UpdateSupport;
import org.apache.taglibs.standard.tag.el.core.ExpressionUtil;

/**
 * Base tag for taking a scoped object and updating via the broker
 *
 * @author <a href="mailto:jacob.hookom@mckesson.com">Jacob Hookom</a>
 * @version $Id: AbstractUpdateTag.java, v 1.0 Jul 13, 2003 9:35:21 PM JHOOK Exp$
 */
public abstract class AbstractUpdateTag extends UpdateSupport
{
	// ***********************************************************
	// Internal State

	private String _value;
	protected String _tagName;

	// ***********************************************************
	// Constructor and Initialization

	/**
	 * Default Constructor for the AbstractOperatorTag
	 */
	public AbstractUpdateTag()
	{
		super();
		this.init();
	}

	/**
	 * Resets the tag's state
	 */
	protected void init()
	{
		this._value = null;
		this._tagName = "update-tag";
	}

	/**
	 * Re-initializes the tag for pooling support by the web container
	 * @see javax.servlet.jsp.tagext.Tag#release()
	 */
	public void release()
	{
		super.release();
		this.init();
	}

	// ***********************************************************
	// Accessors

	public void setValue(String value)
	{
		this._value = value;
	}

	// ***********************************************************
	// Tag Methods

	/**
	 * @see javax.servlet.jsp.tagext.Tag#doStartTag()
	 */
	public int doStartTag() throws JspException
	{
		this.evaluateExpressions();
		return super.doStartTag();
	}

	// ***********************************************************
	// Support Methods

	/**
	 * Evaluates the values
	 * @throws JspException
	 */
	protected void evaluateExpressions() throws JspException
	{
		this.value =
			ExpressionUtil.evalNotNull(
				this._tagName,
				"value",
				this._value,
				Object.class,
				this,
				this.pageContext);
	}
}
