/*
 * BetweenTag.java
 * Created on Apr 7, 2003
 */
package org.apache.ojb.taglib.broker.tags;

import javax.servlet.jsp.JspException;

import org.apache.ojb.broker.query.Criteria;
import org.apache.ojb.taglib.broker.support.BetweenSupport;
import org.apache.taglibs.standard.tag.el.core.ExpressionUtil;

/**
 * For a given property, define the start and end values
 * [QueryTag Child]
 * 
 * @author <a href="mailto:jacob.hookom@mckesson.com">Jacob Hookom</a>
 * @version ##build.version## - Created: Apr 7, 2003 1:08:15 AM
 */
public class BetweenTag extends BetweenSupport
{
	//	***********************************************************
	// Internal State

	private String _start;
	private String _end;
	private String _property;
	protected String _tagName;

	// ***********************************************************
	// Constructor and Initialization

	/**
	 * Default Constructor for the AbstractOperatorTag
	 */
	public BetweenTag()
	{
		super();
		this.init();
	}

	/**
	 * Resets the tag's state
	 */
	protected void init()
	{
		this._start = null;
		this._end = null;
		this._property = null;
		this._tagName = "between";
	}

	/**
	 * Re-initializes the tag for pooling support by the web container
	 * @see javax.servlet.jsp.tagext.Tag#release()
	 */
	public void release()
	{
		super.release();
		this.init();
	}

	// ***********************************************************
	// Accessors

	public void setStart(String start)
	{
		this._start = start;
	}

	public void setEnd(String end)
	{
		this._end = end;
	}

	public void setProperty(String property)
	{
		this._property = property;
	}

	// ***********************************************************
	// Tag Methods

	/**
	 * @see javax.servlet.jsp.tagext.Tag#doStartTag()
	 */
	public int doStartTag() throws JspException
	{
		this.evaluateExpressions();
		return super.doStartTag();
	}

	// ***********************************************************
	// Support Methods

	/**
	 * Evaluates the values
	 * @throws JspException
	 */
	protected void evaluateExpressions() throws JspException
	{
		this.start =
			ExpressionUtil.evalNotNull(
				this._tagName,
				"start",
				this._start,
				Object.class,
				this,
				this.pageContext);

		this.end =
			ExpressionUtil.evalNotNull(
				this._tagName,
				"end",
				this._end,
				Object.class,
				this,
				this.pageContext);

		this.property =
			(String) ExpressionUtil.evalNotNull(
				this._tagName,
				"property",
				this._property,
				Object.class,
				this,
				this.pageContext);
	}

	/* (non-Javadoc)
	 * @see org.apache.ojb.taglib.broker.support.op.BetweenSupport#doProcess()
	 */
	protected void doProcess() throws JspException
	{
		Criteria c = this.getCriteria();
		c.addBetween(this.property, this.start, this.end);
	}

}
