/*
 * CriteriaTag.java
 * Created on Apr 7, 2003
 */
package org.apache.ojb.taglib.broker.tags;

import javax.servlet.jsp.JspException;

import org.apache.ojb.taglib.broker.support.CriteriaSupport;
import org.apache.taglibs.standard.tag.common.core.Util;

/**
 * Allows you to store criteria in a variable
 * 
 * @author <a href="mailto:jacob.hookom@mckesson.com">Jacob Hookom</a>
 * @version ##build.version## - Created: Apr 7, 2003 1:52:20 AM
 */
public class CriteriaTag extends CriteriaSupport
{
	//	***********************************************************
	// Internal State

	private String _var;
	private String _scope;

	// ***********************************************************
	// Constructor and Initialization

	/**
	 * Default Constructor for the AbstractOperatorTag
	 */
	public CriteriaTag()
	{
		super();
		this.init();
	}

	/**
	 * Resets the tag's state
	 */
	protected void init()
	{
		this._var = null;
		this._scope = null;
	}

	/**
	 * Re-initializes the tag for pooling support by the web container
	 * @see javax.servlet.jsp.tagext.Tag#release()
	 */
	public void release()
	{
		super.release();
		this.init();
	}

	// ***********************************************************
	// Accessors

	public void setVar(String var)
	{
		this._var = var;
	}

	public void setScope(String scope)
	{
		this._scope = scope;
	}

	// ***********************************************************
	// Tag Methods

	/**
	 * @see javax.servlet.jsp.tagext.Tag#doStartTag()
	 */
	public int doStartTag() throws JspException
	{
		this.evaluateExpressions();
		return super.doStartTag();
	}

	// ***********************************************************
	// Support Methods

	/**
	 * Evaluates the values
	 * @throws JspException
	 */
	protected void evaluateExpressions() throws JspException
	{
		this.var = this._var;

		this.scope = Util.getScope(this._scope);
	}
}
