/*
 * GroupByTag.java
 * Created on Apr 7, 2003
 */
package org.apache.ojb.taglib.broker.tags;

import javax.servlet.jsp.JspException;

import org.apache.ojb.broker.query.QueryByCriteria;
import org.apache.ojb.taglib.broker.support.GroupBySupport;
import org.apache.taglibs.standard.tag.el.core.ExpressionUtil;

/**
 * Description
 * 
 * @author <a href="mailto:jacob.hookom@mckesson.com">Jacob Hookom</a>
 * @version ##build.version## - Created: Apr 7, 2003 1:36:57 PM
 */
public final class GroupByTag extends GroupBySupport
{
//	***********************************************************
	// Internal State

	private String _property;

	// ***********************************************************
	// Constructor and Initialization

	/**
	 * Default Constructor for the AbstractOperatorTag
	 */
	public GroupByTag()
	{
		super();
		this.init();
	}

	/**
	 * Resets the tag's state
	 */
	protected void init()
	{
		this._property = null;
	}

	/**
	 * Re-initializes the tag for pooling support by the web container
	 * @see javax.servlet.jsp.tagext.Tag#release()
	 */
	public void release()
	{
		super.release();
		this.init();
	}

	// ***********************************************************
	// Accessors

	public void setProperty(String property)
	{
		this._property = property;
	}

	// ***********************************************************
	// Tag Methods

	/**
	 * @see javax.servlet.jsp.tagext.Tag#doStartTag()
	 */
	public int doStartTag() throws JspException
	{
		this.evaluateExpressions();
		return super.doStartTag();
	}

	// ***********************************************************
	// Support Methods

	/**
	 * Evaluates the values
	 * @throws JspException
	 */
	protected void evaluateExpressions() throws JspException
	{
		this.property =
			(String) ExpressionUtil.evalNotNull(
				"groupBy",
				"property",
				this._property,
				Object.class,
				this,
				this.pageContext);
	}

	/* (non-Javadoc)
	 * @see org.apache.ojb.taglib.broker.support.op.ConditionalSupport#doProcess()
	 */
	protected void doProcess() throws JspException
	{
		QueryByCriteria query = this.getQuery();
		query.addGroupBy(this.property);
	}

}
