/*
 * InTag.java
 * Created on Apr 7, 2003
 */
package org.apache.ojb.taglib.broker.tags;

import java.util.Collection;

import javax.servlet.jsp.JspException;

import org.apache.ojb.broker.query.Criteria;
import org.apache.ojb.broker.query.Query;
import org.apache.ojb.taglib.resources.TagResources;

/**
 * Description
 * 
 * @author <a href="mailto:jacob.hookom@mckesson.com">Jacob Hookom</a>
 * @version ##build.version## - Created: Apr 7, 2003 1:32:27 AM
 */
public final class InTag extends AbstractOperatorTag
{

	/* (non-Javadoc)
	 * @see org.apache.ojb.taglib.broker.support.op.ConditionalSupport#doProcess()
	 */
	protected void doProcess() throws JspException
	{
		Criteria c = this.getCriteria();
		if (this.value instanceof Collection)
		{
			c.addIn(this.property, (Collection) this.value);
		}
		else if (this.value instanceof Query)
		{
			c.addIn(this.property, (Query) this.value);
		}
		else
		{
			throw new JspException(
				TagResources.getMessage(
					"IN_VALUE_INVALID",
					this.value,
					Collection.class.getName(),
					Query.class.getName()));
		}
	}

	/* (non-Javadoc)
	 * @see org.apache.ojb.taglib.broker.tags.op.AbstractOperatorTag#init()
	 */
	protected void init()
	{
		super.init();
		this._tagName = "in";
	}

}
