/*
 * TagResources.java
 * Created on Apr 6, 2003
 */
package org.apache.ojb.taglib.resources;

import java.text.MessageFormat;
import java.util.MissingResourceException;
import java.util.ResourceBundle;

/**
 * Description
 * 
 * @author <a href="mailto:jacob.hookom@mckesson.com">Jacob Hookom</a>
 * @version ##build.version## - Created: Apr 6, 2003 11:18:16 PM
 */
public final class TagResources
{
	// ***********************************************************
	// Internal State

	private final static String RESOURCE_LOCATION =
		"org.apache.ojb.taglib.resources.TagResources";
	private final static ResourceBundle rb =
		ResourceBundle.getBundle(RESOURCE_LOCATION);

	// ***********************************************************
	// Static Methods

	/** Retrieves a message with no arguments. */
	public static String getMessage(String name)
		throws MissingResourceException
	{
		return rb.getString(name);
	}

	/** Retrieves a message with arbitrarily many arguments. */
	public static String getMessage(String name, Object[] a)
		throws MissingResourceException
	{
		String res = rb.getString(name);
		return MessageFormat.format(res, a);
	}

	/** Retrieves a message with one argument. */
	public static String getMessage(String name, Object a1)
		throws MissingResourceException
	{
		return getMessage(name, new Object[] { a1 });
	}

	/** Retrieves a message with two arguments. */
	public static String getMessage(String name, Object a1, Object a2)
		throws MissingResourceException
	{
		return getMessage(name, new Object[] { a1, a2 });
	}

	/** Retrieves a message with three arguments. */
	public static String getMessage(
		String name,
		Object a1,
		Object a2,
		Object a3)
		throws MissingResourceException
	{
		return getMessage(name, new Object[] { a1, a2, a3 });
	}

	/** Retrieves a message with four arguments. */
	public static String getMessage(
		String name,
		Object a1,
		Object a2,
		Object a3,
		Object a4)
		throws MissingResourceException
	{
		return getMessage(name, new Object[] { a1, a2, a3, a4 });
	}

	/** Retrieves a message with five arguments. */
	public static String getMessage(
		String name,
		Object a1,
		Object a2,
		Object a3,
		Object a4,
		Object a5)
		throws MissingResourceException
	{
		return getMessage(name, new Object[] { a1, a2, a3, a4, a5 });
	}

	/** Retrieves a message with six arguments. */
	public static String getMessage(
		String name,
		Object a1,
		Object a2,
		Object a3,
		Object a4,
		Object a5,
		Object a6)
		throws MissingResourceException
	{
		return getMessage(name, new Object[] { a1, a2, a3, a4, a5, a6 });
	}

}
