/*
 * OjbUser.java
 * Created on Mar 27, 2003
 */
package org.apache.ojb.taglib.test;

import java.util.Collection;
import java.util.Iterator;
import java.util.LinkedList;

/**
 * Description
 * 
 * @author <a href="mailto:##author.email##">##author.name##</a>
 * @version ##build.version## - Created: Mar 27, 2003 6:25:28 PM
 */
public class BaseUser extends BaseDto implements User
{
	protected String login;
	protected String password;
	protected String email;
	protected String firstName;
	protected String lastName;
	protected String status;
	protected Collection roles;

	/**
	 * 
	 */
	public BaseUser()
	{
		super();
	}

	/**
	 * @return String
	 */
	public String getEmail()
	{
		return email;
	}

	/**
	 * @return String
	 */
	public String getFirstName()
	{
		return firstName;
	}

	/**
	 * @return String
	 */
	public String getLastName()
	{
		return lastName;
	}

	/**
	 * @return String
	 */
	public String getLogin()
	{
		return login;
	}

	/**
	 * @return String
	 */
	public String getPassword()
	{
		return password;
	}

	/**
	 * @return RoleCollection
	 */
	public Collection getRoles()
	{
		if (this.roles == null)
			this.roles = new LinkedList();

		return roles;
	}

	/**
	 * @return String
	 */
	public String getStatus()
	{
		return status;
	}

	/**
	 * Sets the email.
	 * @param email The email to set
	 */
	public void setEmail(String email)
	{
		this.email = email;
	}

	/**
	 * Sets the firstName.
	 * @param firstName The firstName to set
	 */
	public void setFirstName(String firstName)
	{
		this.firstName = firstName;
	}

	/**
	 * Sets the lastName.
	 * @param lastName The lastName to set
	 */
	public void setLastName(String lastName)
	{
		this.lastName = lastName;
	}

	/**
	 * Sets the login.
	 * @param login The login to set
	 */
	public void setLogin(String login)
	{
		this.login = login;
	}

	/**
	 * Sets the password.
	 * @param password The password to set
	 */
	public void setPassword(String password)
	{
		this.password = password;
	}

	/**
	 * Sets the roles.
	 * @param roles The roles to set
	 */
	public void setRoles(Collection roles)
	{
		this.roles = roles;
	}

	/**
	 * Sets the status.
	 * @param status The status to set
	 */
	public void setStatus(String status)
	{
		this.status = status;
	}

	/* (non-Javadoc)
	 * @see org.apache.ojb.taglib.test.User#hasRole(java.lang.String)
	 */
	public boolean hasRole(String role)
	{
		Collection c = this.getRoles();
		Role r = null;
		synchronized (this.roles)
		{
			for (Iterator itr = c.iterator(); itr.hasNext();)
			{
				r = (Role) itr.next();
				if (r.getName().equals(role))
					return true;
			}
		}
		return false;
	}

	/* (non-Javadoc)
	 * @see org.apache.ojb.taglib.test.User#removeRole(java.lang.String)
	 */
	public void removeRole(String role)
	{
		if (role != null)
		{
			Collection c = this.getRoles();
			Collection remove = new LinkedList();
			synchronized (this.roles)
			{
				Role r = null;
				for (Iterator itr = c.iterator(); itr.hasNext();)
				{
					r = (Role) itr.next();
					if (r.getName().equals(role))
					{
						remove.add(r);
					}
				}
			}
			c.removeAll(remove);
		}
	}

	/* (non-Javadoc)
	 * @see org.apache.ojb.taglib.test.User#addRole(java.lang.String)
	 */
	public void addRole(String role)
	{
		if (role != null && !this.hasRole(role))
		{
			Role r = new BaseRole();
			r.setUserId(this.getId());
			r.setName(role);
			this.getRoles().add(r);
		}
	}

}
